package ro.ieval.unical;

import java.util.Locale;

import android.view.View;
import android.view.ViewGroup;

final class Utils {
	private Utils(){ /* do nothing */ }

	public static void setEnabledRecursively(final View view, final boolean enabled){
		view.setEnabled(enabled);
		if(view instanceof ViewGroup){
			final ViewGroup group=(ViewGroup) view;
			for(int i=0;i<group.getChildCount();i++)
				setEnabledRecursively(group.getChildAt(i), enabled);
		}
	}

	public static String formatDate(final int year, final int month, final int day){
		return String.format(Locale.ENGLISH, "%4d-%02d-%02d", year, month, day);
	}
}
